#pragma once

#define OF_ADDON_USING_OFXVECTORMATH
#define OF_ADDON_USING_OFXXMLSETTINGS

#include "ofAddons.h"
#include "ofMain.h"

#include "baseCardScene.h"
#include  "arPlane.h"
#include "arBasicShape.h"
#include "ofxMidi.h"


class bouncingScene : public baseCardScene{
		
	public:
		//----------------------------------
		bouncingScene();
		void setupScene();
		void render();		
		void renderGui();
		void update();
		void exit();
		
		void keyPressed( int key );
		void keyReleased( int key );
		
		void mouseMoved( int x, int y );
		void mouseDragged( int x, int y, int button );
		void mousePressed( int x, int y, int button );
		void mouseReleased(int x, int y, int button );
	
		//void audioReceived( float * input, int bufferSize, int nChannels );
		//void audioRequested( float * output, int bufferSize, int nChannels );
		
		//stuff for defining the plane
		bool recordingPts;
		int whichPt;
		ofPoint planePts[4];
		arPlane plane;
		ofxXmlSettings xml;
		float mx;
		float my;
		
		//for the cards
		arFakeMarker fakeMarker;
		
		ofTrueTypeFont Akzidenz;
		
		//the variables we need for our animation		
		int playingNumber;
		card playingCard; //hahaha funny
		card nextCard;
		int srcID;
		int dstID;
		ofxMidiOut midi;
		int prevNote;
		arBasicShape basicShape;
		float speed;
	
};